<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../polymer/lib/utils/async.html">
<link rel="import" href="./libwebpjs-polyfill.html">
<link rel="import" href="./webp-support.html">
<link rel="import" href="./libwebpjs-viewer.html">
<link rel="import" href="./libwebpjs-demux.html">

<dom-module id="hook-webp-image">
  <template>
    <style>
      :host {
        display: inline-block;
      }
      canvas {
        display: none;
        max-width: 100%;
        @apply --hook-webp-image-canvas;
      }
      canvas.notsupported {
        display: block;
      }
      img {
        max-width: 100%;
        @apply --hook-webp-image-img;
      }
    </style>
    <canvas class$="[[supportedClass]]" id="canvas"></canvas>
    <template is="dom-if" if="[[supported]]">
      <img id="img" src$="[[src]]" />
    </template>
  </template>
  <script>
    /**
     * `hook-webp-image`
     *
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class HookWebpImage extends Polymer.Element {
      static get is() { return 'hook-webp-image'; }
      static get properties() {
        return {
          debug: {
            type: Boolean,
            value: false
          },
          supportedClass: {
            type: String,
            computed: '_computeSupportedClass(supported)'
          },
          supported: {
            type: Boolean,
            notify: true,
            readOnly: true
          },
          initialized: {
            type: Boolean,
            notify: true,
            readOnly: true
          },
          src: {
            type: String,
            notify: true
          },
          viewer: {
            type: Object
          },
          webpdecoder: {
            type: Object
          }
        };
      }

      static get observers() {
        return ['_srcChanged(initialized, src)']
      }

      connectedCallback() {
        super.connectedCallback();
        WebPSupport.supported((supported) => {
          this._setSupported(supported);
          this._setInitialized(true);
        });
      }

      _computeSupportedClass(supported) {
        if(supported) {
          return 'supported';
        }
        return 'notsupported';
      }

      _srcChanged(initialized, src) {
        if(this.debug) {
          console.log('hook-webp-image._srcChanged()', initialized, src);
        }
        if(!initialized || !src) {
          return;
        }
        console.log('hook-webp-image._srcChanged() supported' , this.supported, src);

        if(!this.supported) {
          this._loadAndDrawImage(src);
        }
      }

      _loadAndDrawImage(src) {
        if(this.debug) {
          console.log('hook-webp-image._loadAndDrawImage()', src);
        }
        var request = new Request(src, {
          headers: new Headers({
            'Content-Type': 'text/plain'
          })
        });

        fetch(request, {
          method: 'get'
        }).then((response) => {
          if(this.debug) {
            console.log('hook-webp-image._srcChanged() fetched', response);
          }

          Polymer.Async.idlePeriod.run(() => {
            response.arrayBuffer().then((arrayBuffer) => {
              if(this.debug) {
                console.log('hook-webp-image._srcChanged() arrayBuffer', arrayBuffer);
              }

              this.webpdecoder = new WebPDecoder();

              var stop = false;
              if(this.viewer) {
                stop = true;
                this.viewer.stopdrawing();
              }
              var start = new Date();

              var data = new Uint8Array(arrayBuffer);

              var imagearray = WebPRiffParser(data,0);
              imagearray['response'] = data;
              imagearray['rgbaoutput'] = true;
              imagearray['dataurl'] = false;

              var ctx = this.$.canvas.getContext('2d');
              this.viewer = new WebPImageViewer(this.webpdecoder, imagearray, (frame) => {
                var width = imagearray['header'] ? imagearray['header']['canvas_width'] : frame['imgwidth'];
                var height = imagearray['header'] ? imagearray['header']['canvas_height'] : frame['imgheight'];
                this.$.canvas.height = height;
                this.$.canvas.width = width;

                var imagedata = ctx.createImageData(width, height);
                var rgba = frame['rgbaoutput'];
                for(var i = 0; i < width * height * 4; i++) {
                  imagedata.data[i] = rgba[i];
                }
                ctx.putImageData(imagedata, 0, 0);
              });

            });
          });

        }).catch((err) => {
          if(this.debug) {
            console.error('hook-webp-image._srcChanged() fetch error', err);
          }
        });

      }

      convertBinaryToArray(binary) {
        var arr = new Array();
        var num = binary.length;
        var i;
        for(i = 0; i < num; ++i) {
          arr.push(binary.charCodeAt(i));
        }
        return arr;
      }


    }

    window.customElements.define(HookWebpImage.is, HookWebpImage);
  </script>
</dom-module>
